using System;
using System.Collections.Generic;
using System.Text;
using System.Security.AccessControl;
using System.Security.Principal;
using System.IO;

namespace WriteAcl
{
    class Program
    {
        static void Main(string[] args)
        {
            SetDacl("..\\..\\test.txt");
        }

        static void SetDacl(string filename)
        {
            FileSecurity security = new FileSecurity();

            // neuer eintrag - windows gruppe
            FileSystemAccessRule ruleOps = new FileSystemAccessRule(
              new NTAccount(@"domain\user"),
              FileSystemRights.Modify,
              AccessControlType.Allow);

            // neuer eintrag  Network Service
            FileSystemAccessRule ruleAspNet = new FileSystemAccessRule(
              new SecurityIdentifier(WellKnownSidType.NetworkServiceSid, null),
              FileSystemRights.Read, 
              AccessControlType.Allow);

            // eintrge hinzufgen
            security.AddAccessRule(ruleOps);
            security.AddAccessRule(ruleAspNet);

            // speichern
            File.SetAccessControl(filename, security);
        }
    }
}
